#library(maps)
#library(s2dv)
#library(ncdf4)
library(startR)
#library(ClimProjDiags)

source('/esarchive/scratch/Earth/acarreri/scripts/scripts_HR_forecast/scripts_R/config_timeseries_acc_test.R')

config <- config_timeseries_acc()
expid <- config$expid
model <- config$model
init_month <- config$init_month
vari <- config$vari
compo <- config$compo
membs_num <- config$membs_num
reg <- config$reg
startdates <- config$startdates
length_forecast <- config$length_forecast
membs <- paste0('r', membs_num, 'i1p1f1')

month_init <- month.abb[init_month]
forecast_month <- c(seq(init_month,(init_month+length_forecast-1))) 
nstartdates <- length(startdates)
grid <- 'gn'
final_month = sprintf("%02d", (init_month + length(forecast_month) -1))
print(paste0('final month to load the files: ', final_month))

path <- paste0('/esarchive/exp/ecearth/', expid, '/diags/DCPP/EC-Earth-Consortium/', model, '/dcppA-hindcast/$memb$/', compo, '/$var$/', grid, '/v*/$var$_', compo, '_', model, '_dcppA-hindcast_s$sdate$-$memb$_', grid, '_$chunk$', final_month,'.nc')

reg_startR <- array(reg, dim = c(memb = length(membs), region = 1))
data_exp_call <- Start(dat = path,
                       var = vari,
                       memb = membs,
                       region = reg_startR,
                       region_var = 'region',
                       sdate = startdates,
                       time = 'all',  
                       chunk = 'all',
                       chunk_depends = 'sdate',
                       time_across = 'chunk',
                       merge_across_dims = TRUE,
                       largest_dims_length = c(time = 8),
                       return_vars = list(time=c('sdate','chunk'), region=c('memb')), 
retrieve = T)

