
library(easyVerification)
library(startR)
library(s2dv)
#source("/esarchive/scratch/lpalma/CSTools/R/CST_BiasCorrection.R")
source("/esarchive/scratch/lpalma/CSTools/R/CST_MergeDims.R")
library(ClimProjDiags)
library(reticulate)
library(easyNCDF)

# TODO: change archiv var name by exp_archiv var name or similar
verify_downscale <- function(var,region,fcst.sdate,path.outside,archiv,fcst_type){
  print(fcst_type)
  variable <- var 
  source("/esarchive/scratch/lpalma/git/vitigeoos-prod/data-analysis/Vitigeoos/knn.conf.R")
  source(wf)

  if (fcst_type == "seasonal"){

    anlgs <- paste0(archiv,"/output/system5c3s/monthly_mean/",
                    var,"/",var,"-",region,"_1993-2016_",
                    substr(fcst.sdate,5,8),".nc")

    anlgs_fcst <- paste0(archiv,"/output/system5c3s/monthly_mean/",
                         var,"/",var,"-",region,"_",
                         fcst.sdate,".nc")

    obs.path <- paste0("/esarchive/recon/ecmwf/era5land/monthly_mean/",
                       "/$var$_f1h","/$var$_$file_date$.nc")
    file_dates <- substr(fcst.sdate,5,8)

  } else if (fcst_type == "subseasonal"){

    anlgs <- paste0(archiv,"/output/cfsv2/weekly_mean/",
                    var,"/",var,"-",region,"_1999-2018_",
                    "$file_date$.nc")
  
    anlgs_fcst <- paste0(archiv,"/output/cfsv2/weekly_mean/",
                         var,"/",var,"-",region,"_",
                         fcst.sdate,".nc")
    
    obs.path <- paste0("/esarchive/recon/ecmwf/era5land/weekly_mean/",
                       "/$var$_f1h","/$var$_$file_date$.nc")

# get get.file_dates() from /esarchive/autosubmit/a4e4/proj/S2S4E-backend-BSC/data-analysis/Vitigeoos/tools.R
    file_dates <- get.file_dates(fcst.sdate)
  
  } else {
    print("ERROR: Invalid fcst_type")
  }

  #########################
  # Analogs 
  #########################
  
  if (fcst_type == "seasonal"){
    #hcst <- Start(dat = down,
    hcst <- Start(dat = anlgs,
                  var = var, 
    	            latitude ='all', 
    	            longitude='all', 
    	            member='all', 
    	            time='all', 
    	            syear='all',
    	            longitude_reorder = CircularSort(-180, 180),
    	            latitude_reorder = Sort(),
    	            longitude_var = "longitude",
    	            latitude_var = "latitude",
    	            num_procs = 1, retrieve = T,
                  return_vars = list(leadtimes = NULL),
    	            synonims = list(longitude = c('lon', 'longitude'), 
                                  latitude = c('lat', 'latitude'),
                                  syear = c('sdate','syear'),
                                  member = c('ensemble','member')))
    hcst.reorder <- c("syear","longitude","latitude","member","time")

  } else if (fcst_type == "subseasonal"){
print('HI 1')
    #hcst <- Start(dat = down,
    hcst <- Start(dat = anlgs,
                  var = var, 
    	            latitude ='all', 
    	            longitude='all', 
    	            member='all', 
    	            time='all', 
    	            syear='all', 
    	            file_date=file_dates,
    	            longitude_reorder = CircularSort(-180, 180),
    	            latitude_reorder = Sort(),
    	            longitude_var = "longitude",
    	            latitude_var = "latitude",
    	            num_procs = 1, retrieve = T,
                  return_vars = list(leadtimes = 'file_date'),
                  split_multiselected_dims = TRUE,
    	            synonims = list(longitude = c('lon', 'longitude'), 
                                  latitude = c('lat', 'latitude'),
                                  syear = c('sdate','syear'),
                                  member = c('ensemble','member')))
print("HI 2")                                    
    hcst.reorder <- c("sweek","sday","syear","longitude","latitude","member","time")
  }
 
  lons <- as.vector(attributes(hcst)$Variables$common$longitude)
  lats <- as.vector(attributes(hcst)$Variables$common$latitude)
  hcst <- Subset(hcst,along=c('dat','var'),list(1,1),drop='selected')
  #names(dim(hcst)) <- hcst.dims 
  hcst <- Reorder(hcst,hcst.reorder)
  
  dates <- attr(hcst, 'Variables')$common$leadtimes
print('HI 3')
print('dates')
print(dim(dates))
print(dates[1])

  if(fcst_type == "seasonal"){
    hcst <- InsertDim(hcst,posdim=1,lendim=1,name='sday')
    hcst <- InsertDim(hcst,posdim=1,lendim=1,name='sweek')

    dates_file <- sapply(dates, format, '%Y%m')
    #dates_file <- format(as.Date(dates_file, '%Y%m%d'), "%Y%m%d")
  } else {
    dates_file <- sapply(dates, format, '%Y%m%d')
    dates_file <- format(as.Date(dates_file, '%Y%m%d'), "%Y%m%d")
  }

  dim(dates_file) <- dim(Subset(hcst, 
                                along=c(
                                'latitude', 'longitude', 'member'), 
                                list(1,1,1), drop='selected')) 

  dim(dates) <- dim(Subset(hcst, 
                                along=c(
                                'latitude', 'longitude', 'member'), 
                                list(1,1,1), drop='selected')) 
print('HI 4')
  #########################
  # Observations 
  #########################
  ## WARNING: critical step; make sure that the 
  # data loaded with this call is the appropriate one.
  # Also, ensure that the metadata in the exp and obs files is
  # consistent (ex. same criteria to define leadtimes dates).

  
  #obs <- Start(dat = obs.path,		  
  #             var = var,
  #	           file_date = sort(unique(dates_file)),
  #	           file_date = dates_file,
  #             #time = values(dates),
  #             #time_var = 'time',
  #             #time_across = 'file_date',
  #             merge_across_dims = T,
  #             merge_across_dims_narm = T,
  #             latitude = values(list(min(lats), max(lats))),
  #             longitude = values(list(min(lons), max(lons))),
  #	           longitude_reorder = CircularSort(-180, 180),
  #	           latitude_reorder = Sort(),
  #             synonims = list(latitude=c('lat','latitude'),
  #                             longitude=c('lon','longitude')), 
  #	           return_vars = list(latitude = 'dat',
  #                                longitude = 'dat',
  #                                time = 'file_date'),
  #	           split_multiselected_dims = TRUE,
  #	           retrieve = T)

  obs <- Start(dat = obs.path,		  
               var = var,
  	           file_date = dates_file,
               latitude = values(list(min(lats), max(lats))),
               longitude = values(list(min(lons), max(lons))),
  	           longitude_reorder = CircularSort(-180, 180),
  	           latitude_reorder = Sort(),
               synonims = list(latitude=c('lat','latitude'),
                               longitude=c('lon','longitude')), 
  	           return_vars = list(latitude = 'dat',
                                  longitude = 'dat',
                                  time = 'file_date'),
  	           split_multiselected_dims = TRUE,
  	           retrieve = T)
print('HI 5')

  lons2 <- as.vector(attributes(obs)$Variables$dat1$longitude)
  lats2 <- as.vector(attributes(obs)$Variables$dat1$latitude)
  obs <- Subset(obs,along=c('dat','var'),list(1,1),drop='selected')

  obs <- InsertDim(obs,posdim=7,lendim=1,name='member')
  obs <- Reorder(obs,c("sweek","sday","syear","longitude","latitude","member","time"))
  
  leadtimes.hcst <<- dates

  sdates.hcst <<- array(numeric(), c(dim(hcst)['syear'],dim(hcst)['sweek'],dim(hcst)['sday']))
  hcst.years <- hcst.inityear:hcst.endyear
  for (year in 1:dim(hcst)['syear']){
    sdates.hcst[year,,] <<- paste(hcst.years[year],file_dates,sep="")
  }

  attr(obs, 'Variables')$dat1$longitude <- lons 
  attr(obs, 'Variables')$dat1$latitude <- lats 
  compute_stats(var.obs=obs, var.exp=hcst, agg="GLOBAL", ncores=6)

print('HI fcst')  
  #hcst <- Start(dat = down,
  fcst <- Start(dat = anlgs_fcst,
                var = var, 
  	          latitude ='all', 
  	          longitude='all', 
  	          ensemble='all', 
  	          time='all', 
  	          sdate='all',
  	          longitude_reorder = CircularSort(-180, 180),
  	          latitude_reorder = Sort(),
  	          longitude_var = "longitude",
  	          latitude_var = "latitude",
  	          num_procs = 1, retrieve = T,
  	          synonims = list(longitude = c('lon', 'longitude'), 
                                latitude=c('lat', 'latitude')))

print('HI fcst done')

  #lons <- as.vector(attributes(hcst)$Variables$common$longitude)
  #lats <- as.vector(attributes(hcst)$Variables$common$latitude)
  fcst <- Subset(fcst,along=c('dat','var'),list(1,1),drop='selected')
  names(dim(fcst)) <- c("latitude","longitude","member","time","syear")
  fcst <- Reorder(fcst,c("syear","longitude","latitude","member","time"))
  
  fcst <- InsertDim(fcst,posdim=1,lendim=1,name='sday')
  fcst <- InsertDim(fcst,posdim=1,lendim=1,name='sweek')

  if (fcst_type == "subseasonal"){

    # TODO: hardcoded indices=c(5) to the +- 2 weeks methodology for skill comp.
    compute_fcst_probs(var.obs=Subset(obs,along='sweek',indices=c(5),drop=FALSE),
                       var.hcst=Subset(hcst,along='sweek',indices=c(5),drop=FALSE),
                       var.fcst=fcst,
                       agg="GLOBAL", ncores=6)
print("HI compute_fcst_probs done")
  } else {
    compute_fcst_probs(var.obs=obs, var.hcst=hcst, var.fcst=fcst,agg="GLOBAL",ncores=6)
  }


}




